;Single Key browser helper [include]|0.78
#Persistent
#SingleInstance,Force
#InstallKeybdHook
DetectHiddenWindows,On

Global control, QuickKeys:=false, BrowsingMode:="Typing", SyncWithEnterKey:=false
Global lastBrowser,winTitle
CoordMode,Mouse,Screen

menu,tray,NoStandard
menu,tray,add,1 Key Browsing Info,about
menu,tray,add,
menu,tray,add,Heavy Browsing,ChooseBrowsingMode
menu,tray,add,Heavy Typing,ChooseBrowsingMode
menu,tray,add,Sync with Enter,SyncWithEnter
menu,tray,check,Heavy Typing
menu,tray,add,
menu,tray,add,Exit,quit

;one line GUI to display 'Quick Keys OFF' whenever letter commands are disabled
gui,1:new
Gui,1:-Border -MaximizeBox -MinimizeBox +AlwaysOnTop +ToolWindow	;set window parameters
Gui,1:color,Teal											;set background color
Gui,1:font,s11 cBlack Bold
Gui,1:Margin,0,0
gui,1:add,text,w145 Center vMode,Quick Keys (OFF)
Gui,1:show,w150 h20,InsertMode
WinSet,Style,-0xC00000,InsertMode
WinHide,InsertMode

;GUI to display quick letter keys Help
gui,2:new
gui,2:+Border -MaximizeBox -MinimizeBox +AlwaysOnTop +ToolWindow	;set window parameters
gui,2:add,Picture,,%A_ScriptDir%\1KeyBrowsing-Cheatsheet.gif

GroupAdd, browsers, ahk_exe Firefox.exe
GroupAdd, browsers, ahk_class MozillaWindowClass
GroupAdd, browsers, ahk_exe chrome.exe
GroupAdd, browsers, ahk_class Chrome_WidgetWin_1
;GroupAdd, browsers, ahk_class IEFrame
;GroupAdd, browsers, ahk_exe iexplore.exe

Menu,Tray,Icon,%A_ScriptDir%\Letter-K-grey.ico
Menu,Tray,Tip,1 Key Browsing: OFF

;show/hide Insert mode
SetTimer,WatchCursor,750
OnMessage(0x404, "AHK_NOTIFYICON") 					;clicking on tray icon

;hotstrings definitions ===============================================================
#If WinActive("ahk_group browsers") and (QuickKeys)

?::gui,2:show,,1 Key Browsing - Control Chrome or Firefox with Single Key Commands (ESC to close)	;show Help window

;o to open another URL in a new Tab
:*C:o::
if (QuickKeys)
	gosub,InsertMode
InputBox,url,Enter URL,Go where? (Insert ON),,,,,,,,www.duckduckgo.com
if (ErrorLevel=1)
	return
Send, ^t%url%{Enter}
if not(QuickKeys)
	gosub,InsertMode
return

;jump to numbered Tab
:*:1::Send,^1
:*:2::Send,^2
:*:3::Send,^3
:*:4::Send,^4
:*:5::Send,^5
:*:6::Send,^6
:*:7::Send,^7
:*:8::Send,^8
:*:9::Send,^9

;n for next Tab, p for previous Tab
:*C:n::
Send,^{PgDn}
IfWinActive,New Tab
	Send,!d{BackSpace}
return
:*C:p::
Send,^{PgUp}
IfWinActive,New Tab
	Send,!d{BackSpace}
return

;' use Firefox search withing Links (Ctrl G to move through matching links, press Enter to select)
'::
if (QuickKeys)
	gosub,InsertMode
SendRaw,'
return

;a Mute/Unmute Audio
:*C:a::Send,^m

;e edit current URL
:*C:e::
if (QuickKeys)
	gosub,InsertMode
Send,!d
return

;y yank Tab URL
:*C:y::
Send,!d
Send,^c
ToolTip,URL Yanked to clipboard
Sleep,1000
ToolTip
return

;Y yank Tab Title
:*C:Y::
WinGetActiveTitle,ttl
Clipboard := ttl
ToolTip,Title Yanked to clipboard
Sleep,1000
ToolTip
return

;T Duplicate Tab
:*C:T::
Send,!d
Send,^c
Send,^t
Send,^v{Enter}
return

;t new Tab
:*C:t::
Send,^t
Send,{BackSpace}
if (QuickKeys)
	gosub,InsertMode
return

;d to close Tab
:*C:d::Send,^w
;d undo close Tab
:*C:u::Send,^+t
;p to print Tab
:*C:P::Send,^p

;r to toggle Reader mode
:*C:r::send,{F9}
;R to Refresh current Tab
:*C:R::send,^{F5}

;Zoom In / Out   [ / ]
]::Send,^{NumpadAdd}
[::Send,^{NumpadSub}
\::Send,^0

;g Past History / h History Forward
:*C:g::Send,!{Left}
:*C:h::Send,!{Right}

;show History with H
:*C:H::
if (QuickKeys)
	gosub,InsertMode
Send,^h
return

;Page Down / Up    j / k
:*C:j::Send,{PGUP}
:*C:k::Send,{PGDN}

;Page Top / Bottom    J / K
:*C:J::Send,{Home}
:*C:K::Send,{End}

;b to bookmark Tab
:*C:b::
if (QuickKeys)
	gosub,InsertMode
Send,^d
if not(QuickKeys)
	gosub,InsertMode
return

;B to show bookmarks
:*C:B::
if (QuickKeys)
	gosub,InsertMode
WinGetClass,class,A
if (class = "MozillaWindowClass")
	Send,^b			;Firefox
else if InStr(winTitle,"- Opera")
	Send,+^b		;Opera
else
	Send,^+o		;Chrome
return

;D to show Downloads
:*C:D::
if (QuickKeys)
	gosub,InsertMode
Send,^j
Sleep,1000
Send,{F6}
return

;f to search within Tab
:*C:f::
if (QuickKeys)
	gosub,InsertMode
Send,^f
return

;s/S to search default engine
:*:s::
if (QuickKeys)
	gosub,InsertMode
InputBox,srch,Enter Search phrase (Insert ON),Find what?
if (ErrorLevel=1)
	return
Send, ^t
Send, %srch%{Enter}
gosub,InsertMode
return

;exit browser with Q
:*C:Q::
WinGetClass,class,A
if (class = "MozillaWindowClass")
	Send,^+Q	;Firefox
else
	Send,!fx	;Chrome

;semicolon to turn off quickKeys
`;::
if (QuickKeys)
	gosub,InsertMode
return

#IfWinActive
return

;turn on/off hotstrings/hotkeys with Insert key
~Ins::
;~`;::
;Suspend
InsertMode:	;toggle Insert Mode where ALL characters can be entered
if class not in MozillaWindowClass,Chrome_WidgetWin_1,Shell_TrayWnd
	return
InsertMode2:
QuickKeys:=!(QuickKeys)
if not(QuickKeys) {
	;Suspend,On
	gosub,DisplayInsert
	Menu,Tray,Icon,%A_ScriptDir%\Letter-K-grey.ico
	Menu,Tray,Tip,1 Key Browsing: OFF
}
else {
	;Suspend,Off
	;Gui,1:hide
	gosub,DisplayInsert
	Menu,Tray,Icon,%A_ScriptDir%\Letter-K-green.ico
	Menu,Tray,Tip,1 Key Browsing: ON
}
return

;ctrl+semicolon to turn on quickKeys
^`;::
if not(QuickKeys)
	gosub,InsertMode
return

;Enter to optionally turn quickKeys on/off depen
~Enter::
if not(SyncWithEnterKey)
    return
if (BrowsingMode="Browsing") and not(QuickKeys)
    gosub,InsertMode
if (BrowsingMode="Typing") and (QuickKeys)
    gosub,InsertMode
return

;shift ESC to exit while testing
+Esc::
Suspend
WinActivate,ahk_exe SciTE.exe
ExitApp
return

;F to reFocus on last browser
^+F::
;WinGetClass,class,A
;if class in MozillaWindowClass,Chrome_WidgetWin_1
	WinActivate,%winTitle% ;ToggleWinMinimize(WinTitle)
;else
;	SendRaw, F
return

WatchCursor:	;check current app and show or hide QuickKey in the Title bar
if (A_TimeIdleKeyboard > 30000)	{ ;automatically turn on QuickKeys after 30 seconds of no typing
	if (BrowsingMode = "Browsing") {
        QuickKeys:=true
        Menu,Tray,Tip,1 Key Browsing: ON
	}
    else {
        QuickKeys:=false
        Menu,Tray,Tip,1 Key Browsing: OFF
	}
}
WinGetClass,class,A
if class in MozillaWindowClass,Chrome_WidgetWin_1
{
	lastBrowser:=class
	WinGetActiveTitle,winTitle
	gosub,DisplayInsert
}
else
	WinHide,InsertMode
return

ChooseBrowsingMode:
menu,tray,uncheck,Heavy Typing
menu,tray,uncheck,Heavy Browsing
if (A_ThisMenuItem = "Heavy Browsing") {
    BrowsingMode:="Browsing"
	QuickKeys:=false
}
else {
    BrowsingMode:="Typing"
	QuickKeys:=true
}
menu,tray,check,%A_ThisMenuItem%
gosub,InsertMode2
return

SyncWithEnter:
SyncWithEnterKey:=!SyncWithEnterKey
menu,tray,uncheck,Sync with Enter
if (SyncWithEnterKey)
    menu,tray,Check,Sync with Enter
return

DisplayInsert:
	WinGetActiveStats,A,w,h,x,y
	x := x + (w - 150) / 2
	if (y < 0)	;for full screen browser
		y := 0
	y := y + 5
	txt=Quick Keys
	if (QuickKeys) {
		GuiControl,,Mode,%txt% (ON)
		Gui,1:Font,cWhite Normal
		GuiControl,Font,Mode
		Gui,1:Color,Teal
		Menu,Tray,Icon,%A_ScriptDir%\Letter-K-green.ico
	}
	else {
		GuiControl,,Mode,%txt% (OFF)
		Gui,1:Font,cBlack Bold
		GuiControl,Font,Mode
		Gui,1:Color,Teal
		Menu,Tray,Icon,%A_ScriptDir%\Letter-K-grey.ico
	}
	if class in MozillaWindowClass,Chrome_WidgetWin_1
		Gui,1:show,NA w150 h20 x%x% y%y%,InsertMode
	WinSet,Style,-0xC00000,InsertMode
return

2GuiEscape:
Gui,2:hide
return

;use to get the Window the mouse is over
MouseIsOver(WinTitle) {
    MouseGetPos,,,id
    return WinExist(WinTitle . " ahk_id " . id)
}

WinNotVisible(WinTitle)
{
	WinGet, Style, Style, %WinTitle% 
	Transform, Result, BitAnd, %Style%, 0x10000000 ; 0x10000000 is WS_VISIBLE. 
	if Result <> 0 ;Window is Visible
		Return 0
	Else  ;Window is Hidden
		Return 1
}

ToggleWinMinimize(TheWindowTitle)
{
	;SetTitleMatchMode,2
	DetectHiddenWindows, Off
	;IfWinActive, %TheWindowTitle%
	;	WinMinimize, %TheWindowTitle%
	;Else
		IfWinExist, %TheWindowTitle%
		{
			WinGet, winid, ID, %TheWindowTitle%
			DllCall("SwitchToThisWindow", "UInt", winid, "UInt", 1)
		}
	DetectHiddenWindows, On
}
Return

;routine to check for mouse clicks on the Tray Icon
AHK_NOTIFYICON(wParam,lParam)
{  
	class=Shell_TrayWnd
    if (lParam = 0x202) or (lParam = 0x203)
		gosub,InsertMode
    else if lParam = 0x205       ; WM_RBUTTONUP
		Menu, Tray, Show          ; Show the tray menu
    Return true
}

about:
txt =
(
1 Key Browsing: Speed up your browser experience

1 Key allows many common browser function to be performed
with only single letter commands.

Press the ? key to view all of the 1 Key commands while Firefox or
Chrome browsers are active.

Two modes of operation are: Heavy Browsing and Heavy Typing
The default is Heavy Browsing. This mode prefers Quick Keys On
and will revert to that after 30 seconds of keyboard inactivity.

Users can toggle Quick Keys by pressing the Insert key.
Quick Keys can also be turned Off with the semicolon key.
Pressing Ctrl + semicolon will turn Quick Keys back On.

If you are mainly browsing, choose the first mode from the tray menu.
This mode allows users to freely move between Tabs and Pages w/o a mouse.

If you are typing a lot, choose the second mode. In this mode, the 
program reverts to Quick Key Off after 30 seconds of no keyboard activity.

When you are in Firefox or Chrome, a message will be displayed at the
top showing whether Quick Keys are On or Off.

[ Internet Explorer is not currently supported ]
)
MsgBox,0,1 Key Browsing Info,%txt%
MsgBox,4,Display Quick Key Commands,Click Yes to display the commands now.
IfMsgBox,Yes
	gui,2:show,,1 Key Browsing - Control Chrome or Firefox with Single Key Commands (ESC to close)	;show Help window
return

quit:
MsgBox,4,Quit 1 Key Browsing,Click Yes to Quit the program
IfMsgBox,Yes
	ExitApp
return
